<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <template v-if="isDesktopPlatform">
        <div
          class="page-title"
          v-if="pageTitle"
        >
          {{ pageTitle }}
        </div>
        <div
          class="page-subtitle"
          v-if="pageSubTitle"
        >
          {{ pageSubTitle }}
        </div>
      </template>

      <RequafertiResultsCard
        :fertilization-plan-results="fertilizationPlanResults"
      >
        <template #action-buttons>
          <q-card-section class="q-mt-auto">
            <q-card-actions
              vertical
              align="stretch"
              class="q-pa-none"
            >
              <q-btn
                color="primary"
                text-color="white"
                :loading="saving"
                @click="onClickSavePlan"
              >
                {{ savePlanButtonLabel }}
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="$router.push({name: 'fertilizationPlans'})"
              >
                <translate>Back to all my plans</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </template>
      </RequafertiResultsCard>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import FertilizationPlanMixin from 'src/pages/fieldbook/fertilization/mixins/FertilizationPlanMixin'
import RequafertiI18nMixin from 'src/pages/fieldbook/fertilization/algorithms/requaferti/mixins/RequafertiI18nMixin'
import RequafertiResultsCard from 'src/pages/fieldbook/fertilization/algorithms/requaferti/components/RequafertiResultsCard'

export default {
  name: 'RequafertiResultsPage',
  components: {
    GenericLayout,
    Header,
    Footer,
    RequafertiResultsCard
  },
  mixins: [PlatformMixin, AlgorithmsMixins, FertilizationPlanMixin, RequafertiI18nMixin],
  computed: {
    pageTitle () {
      return this.$gettext('Results')
    },
    pageSubTitle () {
      return 'Requaferti'
    },
    plot () {
      return this.$store.state.fertilizationPlan.target
    },
    fertilizationPlanParameters () {
      return this.$store.state.fertilizationPlan.parameters
    },
    fertilizationPlanResults () {
      return {
        plot_id: this.plot.id,
        plot_name: this.plot.name,
        plant_species_id: this.fertilizationPlanParameters.cropProfile.id,
        plant_species_name: this.fertilizationPlanParameters.cropProfile[this.getRequafertiI18NFieldName('libelle')],
        crop_yield: this.fertilizationPlanParameters.cropTargetYield,
        crop_yield_unit: this.fertilizationPlanParameters.cropTargetYieldUnit,
        element_recommendations: this.fertilizationPlanParameters.results.recommendations
      }
    }
  },
  methods: {
    onClickPrevious () {
      this.$router.replace({
        name: 'requafertiOrganicManure'
      })
    },
    onClickSavePlan () {
      this.savePlan(this.fertilizationPlanResults)
    }
  }
}
</script>
